
#define TOC_OFFSET 0x0200
#define TOC_LENGTH 0x0100

#define INVALID_OFFSET 0xFFFFFFFF

#define ASCII_MODE 0
#define DUALBYTE_MODE 1

typedef struct
{
  unsigned long offset;
  int length;
  int midiOffset;
  unsigned long unknown;
} SongEntry;

unsigned long get32(FILE *f);
void put32(FILE *f, unsigned long tmp);
int getTableOfContents(FILE *inFile, unsigned long toc[TOC_LENGTH]);
int getSongEntryTable(FILE *inFile, unsigned long offset, SongEntry songEntry[TOC_LENGTH]);
int ReadLyricDat(FILE *inFile, int offset, FILE *outFile, int length, int mode=ASCII_MODE);
unsigned int findMidi(FILE *f);
void findLyric(FILE *f, unsigned int len);
void mapLyric(FILE *f, FILE *outFile, int keyLength);
void mapLyric2b(FILE *f, FILE *outFile, int keyLength);
void makeMap(FILE *f);
void writeDat(FILE *lyricsFile, FILE *midiFile, FILE *outFile, int mode=ASCII_MODE);
